<template>
    <base-dialog :show="!!error" title="Create new category" @close="handleError">
        <p>{{ error }}</p>
    </base-dialog>
    <base-spinner v-if="isLoading"></base-spinner>
  <section>
    <base-card>
      <ul>
        <article-detail v-if="article"
                      :key="article.id"
                      :article="article"
        ></article-detail>
        <h3 v-else>No article found.</h3>
      </ul>
    </base-card>
  </section>
</template>

<script>
import ArticleDetail from '../../components/articles/ArticleDetail.vue';

export default {
    components: {
      ArticleDetail,
    },
    props: ['slug'],
    data() {
        return {
            error: null,
            isLoading: false,
        };
    },
    computed: {
        article() {
            return this.$store.getters['articles/article'];
        },
    },
    created() {
        this.loadArticle();
    },
    methods: {
        async loadArticle() {
            this.isLoading = true;
            try {
                await this.$store.dispatch('articles/loadArticle', this.slug);
            } catch (error) {
                this.error = error.message || 'Something went wrong!';
            }
            this.isLoading = false;
        },
        handleError() {
            this.error = null;
        },


    },
};
</script>

<style scoped>
ul {
    list-style: none;
    margin: 0;
    padding: 0;
}

.controls {
    display: flex;
    justify-content: space-between;
}
</style>
